program main

    implicit none
    
    character (len=4) :: c
    integer :: i, iur, k
    integer :: kaprekar, imax, kmax

    kmax = 0
    write (*,"(a/10x,a/20x,a)") "     Start", "#Iterationen", "Kaprekarzahl"
    do i = 0, 9999
        ! Testen ob i vier gleiche Ziffern hat
        write(unit=c,fmt="(i4.4)") i
        if ( c(1:1) .eq. c(2:2) .and. c(1:1) .eq. c(3:3) .and. c(1:1) .eq. c(4:4) ) then
            write (*,"(i10,a)") i, "-------------------- disqualifiziert"
            cycle ! konvergiert gegen 0
        end if
        iur = i
        k = kaprekar(iur)
        if ( k .gt. kmax ) then
            kmax = k
            imax = i
        end if
        write (*,"(3i10)") i, k, iur
    end do

    write( *,"(/a,i5,5x,a,i5/)") "max Anzahl Schritte: ",kmax, "erstmalig mit Startzahl: ", imax    

end program

integer function kaprekar ( iur )

    implicit none
    
    character (len=4) :: c
    integer, dimension(4) :: v ! Vektor
    integer :: i, ineu, iur, j, x, y, cnt
    
    cnt = 0
    do ! Iteration
        cnt = cnt + 1
        write (unit=c, fmt="(i4.4)") iur
        read (unit=c, fmt="(4i1)") v
        do i=1, 4
            j = minloc(v(i:), dim=1) + i - 1 ! selection sort
            write (unit=c(i:i), fmt="(i1)") v(j)
            v(j) = v(i)
        end do
        read (unit=c, fmt="(i4)") y ! klein
        read (unit=c, fmt="(4i1)") v(4:1:-1) ! umdrehen
        write (unit=c, fmt="(4i1)") v ! rueckwaerts
        read (unit=c, fmt="(i4)") x ! gross
        ineu = x - y
        !write (unit=*, fmt="(5i10.4)") iur, x, y, ineu, cnt
        if ( ineu == iur ) then
            kaprekar = cnt -1 
            return
        end if
        iur = ineu
    end do

end function kaprekar
